# Running fylr.exe

For license info see the file LICENSE.

## dependencies

### elasticsearch

mandatory

what we tested:

downloaded from https://www.elastic.co/guide/en/elasticsearch/reference/current/zip-windows.html

unpacked official windows release file elasticsearch-8.5.3-windows-x86_64.zip

disabled security with ...
```
xpack.security.enabled: false
```
... in elasticsearch-8.5.3\config\elasticsearch.yml

The analysis-icu plugin has been downloaded from https://www.elastic.co/guide/en/elasticsearch/plugins/current/analysis-icu.html for offline installation:

https://artifacts.elastic.co/downloads/elasticsearch-plugins/analysis-icu/analysis-icu-8.5.3.zip
... and unpacked into elasticsearch-8.5.3\plugins\analysis-icu\ (no further subfolders)
Assuming you are in the directory of fylr.exe, in a Windows powershell.

started it with

```
.\elasticsearch-8.5.3\bin\elasticsearch.bat
```

Elasticsearch then used the default address `http://localhost:9200`, which is configured in `fylr.yml`.

With default settings, 11,7 GB free RAM *was* enough. Tweaking java settings, even only 2 or 3 GB for Java *should* be enough.

### start with minimal dependencies

You are now ready to start fylr at all, although most asset processing tools are still missing.


```
.\fylr.exe server
```

... in the folder where fylr.exe is.

For a full installation it is recommended to install all of the following and activate them in `fylr.yml` ...

### magick.exe

... taken out of ImageMagick-7.1.0-portable-Q16-x64.zip from https://imagemagick.org/script/download.php#windows ("Portable Win64 static at 16 bits-per-pixel component")

Hint from the [download page](https://imagemagick.org/script/download.php#windows):

> If you have any problems, you likely need vcomp120.dll. To install it, download Visual C++ Redistributable Package(https://support.microsoft.com/en-us/help/2977003/the-latest-supported-visual-c-downloads).

### convert.exe

... is from the same package as magick.exe

### composite.exe

... is from the same package as magick.exe

### exiftool.exe

Version 12.44 from http://exiftool.sourceforge.net

### ffmpeg.exe 

Version n5.1-27-g6f53f0d09e-20220831 out of package ffmpeg-n5.1-27-g6f53f0d09e-win64-gpl-5.1.zip from https://github.com/BtbN/FFmpeg-Builds/releases

### ffprobe.exe

... from the same package as ffmpeg.exe

### ffmpegthumbnailer

There is currently no prepared Windows version available.

### node.exe

We used v16.17.0 out of package node-v16.17.0-win-x64.7z from https://nodejs.org/dist/v16.17.0/

### python.exe

Is Version 3 out of Windows embeddable package (64-bit) at https://www.python.org/downloads/windows/ (explained here: https://docs.python.org/3/using/windows.html#windows-embeddable)

### java

The "metadata" service needs a "java" service.

documentation on how we installed it is yet to come

### xlstproc service

We installed it with the "choco" package manager.

```
xsltproc.exe --version
Using libxml 20903, libxslt 10128 and libexslt 817
```

### ghostscript

Ghostscript is just 4 files. We used its default installation to `C:\Program Files (x86)\gs\gs10.00.0\bin`:

```
-a----         9/21/2022   3:09 PM          86528 gs.exe
-a----         9/21/2022   3:09 PM       22751744 gsdll32.dll
-a----         9/21/2022   3:09 PM          12018 gsdll32.lib
-a----         9/21/2022   3:09 PM          95744 gswin32.exe
-a----         9/21/2022   3:09 PM          86528 gswin32c.exe
```

We then copied "gswin32c.exe" to "gs.exe" so that convert.exe is able to find it.

### libreoffice

We used LibreOfficePortable so that the files were in ...

```
    Directory: C:\Users\myself\fylr_windows\LibreOfficePortable

Mode                 LastWriteTime         Length Name
----                 -------------         ------ ----
d-----        11/16/2022  12:23 PM                App
d-----        11/16/2022   5:40 PM                Data
d-----        11/16/2022  12:24 PM                Other
-a----          5/5/2012   9:22 PM           7688 help.html
-a----         8/13/2020   6:15 AM         188296 LibreOfficeBasePortable.exe
-a----         8/13/2020   6:15 AM         181640 LibreOfficeCalcPortable.exe
-a----         8/13/2020   6:16 AM         180104 LibreOfficeDrawPortable.exe
-a----         8/13/2020   6:16 AM         180112 LibreOfficeImpressPortable.exe
-a----         8/13/2020   6:16 AM         180112 LibreOfficeMathPortable.exe
-a----        10/19/2022   6:16 AM         243240 LibreOfficePortable.exe
-a----         8/13/2020   6:16 AM         184192 LibreOfficeWriterPortable.exe
```

### inkscape

We installed Inkscape 1.2 via its default Installer, below the directory of this unpacked zip.

We did not use a delegates.xml for convert. So gs.exe + inkspace.exe had to be in `%PATH%`.

-------

## Start fylr

```
.\fylr.exe server
```

... in the folder where fylr.exe is.

Output lines with `WRN` can usually be ignored. Errors known to appear are e.g. `Error occurred in NewIntrospectionRequest` and `Accepting token failed`, when a browser tries to use old credentials.


# Access the web frontend

Browse [http://localhost](http://localhost)

Default login credentials are:
- **Username**: *root*
- **Password**: *admin*


## cleanup

If you want to go back to a fresh state between two test runs:
* Stop fylr.exe and elasticsearch. Check that java / openjdk is stopped alongside elasticsearch.
* Remove the directory `data` and elasticsearch's data/*


-------


# Packaging

You do not need the following paragraphs to start fylr. They document which components were used and from where.

## fylr.exe

https://github.com/programmfabrik/fylr as windows amd64

go releaser parameters see https://github.com/programmfabrik/fylr/blob/main/.goreleaser.yml#L340

## utils/fylr_*

https://github.com/programmfabrik/fylr/tree/main/utils

go releaser parameters see https://github.com/programmfabrik/fylr/blob/main/.goreleaser.yml#L354 and following lines

## webfrontend

included from https://github.com/programmfabrik/easydb-webfrontend
* after `make all`
* the folder `build` as `webfrontend` in the zip

## resources

included https://github.com/programmfabrik/fylr/tree/main/resources
* which is not publicly available
* after `make generate`
* as folder `resources`
* same commit as fylr

